/*
 *   This file is a part of the SteamWar software.
 *
 *   Copyright (C) 2025 SteamWar.de-Serverteam
 *
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU Affero General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *   GNU Affero General Public License for more details.
 *
 *   You should have received a copy of the GNU Affero General Public License
 *   along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

package de.steamwar.bausystem;

import de.steamwar.bausystem.config.BauServer;
import de.steamwar.bausystem.features.world.BauMemberUpdate;
import de.steamwar.bausystem.linkage.GuiItem;
import de.steamwar.sql.BauweltMember;
import de.steamwar.sql.SteamwarUser;
import lombok.AllArgsConstructor;
import org.bukkit.entity.Player;

import java.util.function.Predicate;

@AllArgsConstructor
public enum Permission {

    OWNER(bauweltMember -> false),
    SUPERVISOR(bauweltMember -> {
        return bauweltMember.isSupervisor();
    }),
    BUILD(bauweltMember -> {
        return bauweltMember.isBuild() || SUPERVISOR.permissionPredicate.test(bauweltMember);
    }),
    /**
     * Only used for {@link BauMemberUpdate}
     */
    SPECTATOR(bauweltMember -> {
        return !bauweltMember.isBuild() && !bauweltMember.isSupervisor();
    }),
    /**
     * Primarily used for {@link GuiItem}
     */
    MEMBER(bauweltMember -> {
        return true;
    });

    private final Predicate<BauweltMember> permissionPredicate;

    public boolean hasPermission(BauweltMember bauweltMember) {
        if (bauweltMember == null) return false;
        return permissionPredicate.test(bauweltMember);
    }

    public boolean hasPermission(Player member) {
        if (SteamwarUser.get(member.getUniqueId()).getId() == BauServer.getInstance().getOwnerID()) {
            return this != SPECTATOR;
        }
        BauweltMember bauweltMember = BauweltMember.getBauMember(BauServer.getInstance().getOwner(), member.getUniqueId());
        if (bauweltMember == null) return this == SPECTATOR;
        return permissionPredicate.test(bauweltMember);
    }
}